(function(){
    if(!Contentstack) {
        alert('Please add Contentstack Library');
    } else {
        var clearAll = document.getElementById('all');
        var clearByContentType = document.getElementById('content_type');
        var clearByQuery = document.getElementById('query');
        var wrapper, Stack;

        function DOMCreation(entry, html) {
            if(entry) {
                html+='<div class="panel panel-default"><div class="panel-heading" role="tab"><h4 class="panel-title"><a role="button" data-toggle="collapse" data-parent="#accordion" href="#'+entry.uid+'" aria-expanded="true" aria-controls="'+entry.uid+'">';
                html+=entry.title+'</a></h4></div><div id="'+entry.uid+'" class="panel-collapse collapse" role="tabpanel"><div class="panel-body">';
                html+=entry.body+' </div></div></div>';
            }
            return html;
        }

        function singleEntry (contentTypeUid, entryUid) {
            var contentTypeUid = contentTypeUid || "news"
            var entryUid = entryUid || "news_uid"

            Stack
                .ContentType(contentTypeUid)
                .Entry(entryUid)
                .fetch()
                .then(function(data) {
                    // result object with entry
                    var html = '<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">';
                    html = DOMCreation(data.toJSON(), html);
                    html+='</div>';
                    wrapper.innerHTML = html;
                }, function(err) {
                    console.info('News could not fetched.');
                });
        }

        function allEntries (contentTypeUid) {
            var contentTypeUid = contentTypeUid || "news"

            Stack
                .ContentType(contentTypeUid)
                .Query()
                .find()
                .then(function(data) {
                    if(data && data.length && data[0].length) {
                        var html = '<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">';
                        for(var i = 0, _i = data[0].length; i < _i; i++) {
                            html = DOMCreation(data[0][i].toJSON(), html);
                        }
                        html+='</div>';
                        wrapper.innerHTML = html;
                    } else {
                        console.info('News could not fetched.');
                    }
                }, function(err) {
                    console.info('Error : '+err);
                });
        }

        window.onload = function() {
            wrapper = document.getElementById('wrapper')
            Stack = Contentstack.Stack({'api_key': 'bltsomething1234', 'access_token': 'bltsomething1234asdf', 'environment': 'development'})

            // get single the entry
            singleEntry("blog_content_type", "blt1234567890")

            // get all the entries
            allEntries("blog_content_type")
        }
    }
}());